import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class SinglyLinkedListTest extends TestCase {
  
  private SinglyLinkedList list = null;
  
  /**
   * Method to set-up the tests
   */
  protected void setUp()
  {
    list = new SinglyLinkedList(new ListNode("Red",null));
  }
  
  /**
   * A test method.
   * Tests the create of a sinle node list.  Tests get value and get next.
   * Tests the size of the list.
   */
  public void testCreate() {
    assertEquals("Create test size failed",1,list.size());
    ListNode node = list.getHead();
    String value = (String) node.getValue();
    assertTrue("Create test check value failed",value.equals("Red"));
    assertTrue("Create test check next failed",node.getNext() == null);
  }
  
  /**
   * A test method.
   * Tests adding a node to the front of an existing list.
   * Tests setting the head to null
   * Tests add a node to a list with no nodes
   */
  public void testAdd() {
    ListNode addNode = new ListNode("Blue",null);
    list.addToFront(addNode);
    assertEquals("Add test first size failed",2,list.size());
    list.setHead(null);
    list.addToFront(addNode);
    assertEquals("Add test second size failed",1,list.size());
    list.setHead(null);
    list.addToEnd(addNode);
    assertEquals("Add test third size failed",1,list.size());
    list.addToEnd(new ListNode("Green",null));
    assertEquals("Add test fourth size failed",2,list.size());
    ListNode node = list.getHead();
    String value = (String) node.getValue();
    assertTrue("Create test check value failed",value.equals("Blue"));
    
  }
  

  
}
