
/**
 * Interface that describes a priority queue.  The objects with the highest
 * priority will have the minimum value as indicated by the Comparable interface
 */
public interface PriorityQueue
{
  /** true if the queue is empty else false */
  public boolean isEmpty();
  
  /** add an object of the type comparable to the queue */
  public void add(Object object);
  
  /** remove and return the minimum object */
  public Object removeMin();
  
  /** return the minimum object, but do not remove it */
  public Object peekMin();
}
                  
                  
                 
  