import java.util.*;

/**
 * Class that implements a queue using a doubly linked list 
 * @author Barb Ericson
 * Copyright 2004 Georgia Tech
 */
public class LinkedListQueue implements Queue
{
  
  //////////////// fields //////////////////////
  
  /** Linked list to hold the objects in the queue */
  private LinkedList list = new LinkedList();
  
  ///////////////// constructors ///////////////
  
  /**
   * No argument constructor 
   */
  public LinkedListQueue () {}
  
  ///////////////// methods /////////////////////
  
  /**
   * Method to check if the queue is empty 
   * @return true if empty else false
   */
  public boolean isEmpty()
  {
    return (list.size() == 0);
  }
  
  /**
   * Method to add an object to the end of the queue 
   * @param obj the object to add
   */
  public void enqueue(Object obj) 
  {
    list.addLast(obj);
  }
  
  /**
   * Method to return the first object and remove it
   * from the queue
   * @return the first element in the queue
   */
  public Object dequeue()
  {
    return list.remove(0);
  }
  
  /**
   * Method to return the first object but not remove it
   * from the queue
   * @return the first element in the queue
   */
  public Object peekFront() 
  { 
    return list.getFirst();
  }
  
  /**
   * Main method to test 
   */
  public static void main(String[] argv)
  {
    Queue queue = new LinkedListQueue();
    queue.enqueue("Hi");
    queue.enqueue("Barb");
    System.out.println(queue.isEmpty());
    System.out.println(queue.peekFront());
    System.out.println(queue.dequeue());
    System.out.println(queue.dequeue());
    System.out.println(queue.isEmpty());
  }

}