import java.util.*;

/**
 * Class that represents a stack using an array list
 * @author Barb Ericson
 * Copyright 2004 Georgia Tech
 */
public class ArrayListStack implements Stack
{
  //////////////// fields /////////////////////////
  List list = new ArrayList();
  
  ////////////// constructors /////////////////////
  
  /**
   * A no-argument constructor 
   */
  public ArrayListStack()
  {
  }
  
  ///////////////// methods ///////////////////////
  
  /** 
   * Method that returns true if the stack is empty else false 
   * @return true if the stack is empty else false
   */
  public boolean isEmpty() 
  {
    return (list.size() == 0);
  }
  
  /** 
   * Method that adds the passed object to the stack 
   * @param obj the object to add to the stack
   */
  public void push(Object obj)
  {
    list.add(obj);
  }
  
  /** 
   * Method that returns the object at the top of the stack and 
   * removes the object from the stack 
   * @return the object from the top of the stack (last in)
   */
  public Object pop()
  {
    int lastIndex = list.size() - 1;
    Object last = list.remove(lastIndex);
    return last;
  }
  
  /**
   * Method that returns the object at the top of the stack but leaves
   * it on the stack
   */
  public Object peekTop()
  {
    int lastIndex = list.size() - 1;
    Object last = list.get(lastIndex);
    return last;
  }
  
  /**
   * Method to returna string with the items on the stack starting at the top
   * @return a string with the items on the stack from top to bottom
   */
  public String toString()
  { 
    String result = "";
    for (int i= list.size() - 1; i >= 0; i--)
      result = result + list.get(i) + " " ;
    return result;
  }
  
}